eps = 0.01;

thickness = 5;
width = 70;
length = width;
height = 45;

hole_height = thickness/2 + 0.5;
hole_width = thickness/2;
hole_length = 20;

m3_hole_dia = 2.7;
m3_hole_height = thickness*2;

/*
module so239() { // four holes
    front_d = 16;
    front_off = 18.8;
    front_hole_d = 3.2;
    translate([0, 0, 0]) rotate([90,0,0])
        cylinder(d=front_d,h=20, $fn=100, center=true);
    
    translate([-front_off/2, 0, -front_off/2]) rotate([90,0,0])
        cylinder(d=front_hole_d,h=20,$fn=100, center=true);
    
    translate([front_off/2, 0, -front_off/2]) rotate([90,0,0])
        cylinder(d=front_hole_d,h=20,$fn=100, center=true);
    
    translate([front_off/2, 0, front_off/2]) rotate([90,0,0])
        cylinder(d=front_hole_d,h=20,$fn=100, center=true);
    
    translate([-front_off/2, 0, front_off/2]) rotate([90,0,0])
        cylinder(d=front_hole_d,h=20,$fn=100, center=true);
}
*/

module so239() { // two holes
    front_d = 16;
    front_off = 18.8;
    front_hole_d = 3.2;
    
    rotate([0, 45, 0]) {
        translate([0, 0, 0]) rotate([90,0,0])
            cylinder(d=front_d,h=20, $fn=100, center=true);
    
        translate([-front_off/2, 0, -front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
    
        translate([front_off/2, 0, front_off/2]) rotate([90,0,0])
            cylinder(d=front_hole_d,h=20,$fn=100, center=true);
    }
}

module top_hole() {
    translate([(width-thickness)/2, (length-thickness)/2, height-thickness/2- m3_hole_height/2+eps])
        cylinder(h=m3_hole_height, d=m3_hole_dia, center=true, $fn=100); 
}

module box_side() {
    difference() {
        union() {
            translate([(width-thickness)/2, thickness/2, height/2]) {
                cube([thickness, length-thickness, height-thickness], center=true);
                translate([thickness, 0, thickness/2])
                cube([thickness, length+thickness, height], center=true);
            }
        }
        
        top_hole();
    }
}

module bottom() {
    difference() {
        cube([width+thickness*2, length+thickness*2, thickness], center=true);
    }
}

module right_side() {
    rotate([0,0,   0]) box_side();
}

module back_side() {
    difference() {
        rotate([0,0,  90]) box_side();
    }
}

module left_side() {
    rotate([0,0, 180]) box_side();
}

module front_side() {
    rotate([0,0, 270]) box_side();
}

module top() {
    difference() {
        translate([0, 0, height])
            cube([width-1.0, length-1.0, thickness], center=true);
    
        translate([0,0,m3_hole_height/2]) {
            rotate([0,0,   0]) top_hole();
            rotate([0,0,  90]) top_hole();
            rotate([0,0, 180]) top_hole();
            rotate([0,0, 270]) top_hole();
        }
    }
}

// % top();

int_hole_dia = 35;

difference() {
    union() {
        bottom();
        right_side();
        back_side();
        left_side();
        front_side();
    }

    translate([0, length/2, height/2])
        so239();
    
    rotate([0, 0, 90]) 
        translate([0, length/2, height/2])
            so239();
    
    rotate([0, 0, -90]) 
        translate([0, length/2, height/2])
            so239();
    
    translate([-width/2+thickness/2, 0, height/2]) rotate([0,90,0])
        cylinder(h=thickness+eps, d=int_hole_dia, center=true, $fn=100);
    translate([width/2-thickness/2, 0, height/2]) rotate([0,90,0])
        cylinder(h=thickness+eps, d=int_hole_dia, center=true, $fn=100);
    translate([0, width/2-thickness/2, height/2]) rotate([90,0,0])
        cylinder(h=thickness+eps, d=int_hole_dia, center=true, $fn=100);
    translate([0, -width/2+thickness/2, height/2]) rotate([90,0,0])
        cylinder(h=thickness+eps, d=int_hole_dia, center=true, $fn=100);
}